//
// dpwedefs.h
// 
// Standard include file for c++
// 
// dpwe@interval.com, 1994aug09
//

#ifndef _DPWEDEFS_H
#define _DPWEDEFS_H

#ifdef DEBUG
#define DBGFPRINTF(a)	fprintf a
#else /* DEBUG */
#define DBGFPRINTF(a)	/* nothing */
#endif /* DEBUG */

static inline int max(int a, int b)
{ return a>b?a:b; }
static inline int min(int a, int b)
{ return a<b?a:b; }

static inline long lmax(int a, int b)
{ return a>b?a:b; }
static inline long lmin(int a, int b)
{ return a<b?a:b; }

#ifndef NULL
#define NULL 0
#endif /* NULL */

static inline void floatset(float *buf, int len, double val)
{
    while(len--)	*buf++ = val;
}

static inline void floatcopy(float *dest, float *src, int len)
{   /* copy, safe for overlapping regions */
    if(dest > src)   {   /* beg. of dest may overlap end of source */
	dest += len;	src += len;
	while(len--)  {
	    *--dest = *--src;
	}
    } else {  /* src > = dest, so end of dest may hit front of src */
	while(len--)  {
	    *dest++ = *src++;
	}
    }
}

#endif /* _DPWEDEFS_H */

	
