#!/usr/local/bin/sowish -f
# tcl script monitors audio input channel on SGI (through little
# tcl added function) and pops up an icon if someone is listening.
#
# dpwe 1994nov15

label .lab -bitmap @$env(HOME)/src/tcl/ear1.xbm -fg yellow -bg red
pack .lab
# wm iconify .

sound so
so open "/usr/people/dpwe/sound/someone.aif"

proc check_ear1 {} {
    check_ear
}
    
proc check_ear {} {
    # check the audiostatus
    set state [wm state .]
    set inputstatus [lindex [audiostatus] 3]
#    puts $inputstatus
    if { $inputstatus != 0 }  {
	# someone is listening
	if { $state == "iconic" }  {
	    # .. but the icon is down - pop up!
	    wm deiconify .
	    # ring the bell too
	    bell
	    so play
	    # change the colors
	    .lab config -fg yellow -bg red
	}
    } else {
	# no-one listening
	if { $state == "normal" }  {
	    # but icon is up!
	    wm iconify .
	    # make colors sombre
	    .lab config -fg gray80 -bg gray20
	}
    }
    # arrange for this to be repeated in 5 seconds
    after 5000 "check_ear1"
}

check_ear

